#include <PSX/System/IOPorts/SPU_IO.hpp>
#include <PSX/System/IOPorts/IOPort.hpp>

namespace SPU {
    using namespace Port;

    static void clear_key() {
        Key::off.write(UI32_MAX);
    }

    static void clear_main_volume() {
        static constexpr auto StartVol = SweepVolume().clear_bit(SweepVolume::SweepEnable).set_value(static_cast<int16_t>(I16_MAX >> 2), SweepVolume::Volume);

        MainVolume::left.write(StartVol);
        MainVolume::right.write(StartVol);
    }

    static void clear_control_register() {
        Control.write(ControlRegister());
    }

    void setup() {
        clear_key();
        clear_main_volume();
        clear_control_register();
    }
}